/**
 * Copyright (c) 2021 Contributors to the Eclipse Foundation
 *
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Do not edit: This file is generated by Xtext
 */
grammar InternalActivity;

options {
	superClass=AbstractInternalContentAssistParser;
	backtrack=true;
}

@lexer::header {
package org.eclipse.lsat.activity.teditor.ide.contentassist.antlr.internal;

// Hack: Use our own Lexer superclass by means of import. 
// Currently there is no other way to specify the superclass for the lexer.
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.Lexer;
}

@parser::header {
package org.eclipse.lsat.activity.teditor.ide.contentassist.antlr.internal;

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.DFA;
import org.eclipse.lsat.activity.teditor.services.ActivityGrammarAccess;

}
@parser::members {
	private ActivityGrammarAccess grammarAccess;

	public void setGrammarAccess(ActivityGrammarAccess grammarAccess) {
		this.grammarAccess = grammarAccess;
	}

	@Override
	protected Grammar getGrammar() {
		return grammarAccess.getGrammar();
	}

	@Override
	protected String getValueForTokenName(String tokenName) {
		return tokenName;
	}
}

// Entry rule entryRuleActivitySet
entryRuleActivitySet
:
{ before(grammarAccess.getActivitySetRule()); }
	 ruleActivitySet
{ after(grammarAccess.getActivitySetRule()); } 
	 EOF 
;

// Rule ActivitySet
ruleActivitySet 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getActivitySetAccess().getGroup()); }
		(rule__ActivitySet__Group__0)
		{ after(grammarAccess.getActivitySetAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleImport
entryRuleImport
:
{ before(grammarAccess.getImportRule()); }
	 ruleImport
{ after(grammarAccess.getImportRule()); } 
	 EOF 
;

// Rule Import
ruleImport 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getImportAccess().getGroup()); }
		(rule__Import__Group__0)
		{ after(grammarAccess.getImportAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleActivity
entryRuleActivity
:
{ before(grammarAccess.getActivityRule()); }
	 ruleActivity
{ after(grammarAccess.getActivityRule()); } 
	 EOF 
;

// Rule Activity
ruleActivity 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getActivityAccess().getGroup()); }
		(rule__Activity__Group__0)
		{ after(grammarAccess.getActivityAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleResourceQualifiedName
entryRuleResourceQualifiedName
:
{ before(grammarAccess.getResourceQualifiedNameRule()); }
	 ruleResourceQualifiedName
{ after(grammarAccess.getResourceQualifiedNameRule()); } 
	 EOF 
;

// Rule ResourceQualifiedName
ruleResourceQualifiedName 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getResourceQualifiedNameAccess().getGroup()); }
		(rule__ResourceQualifiedName__Group__0)
		{ after(grammarAccess.getResourceQualifiedNameAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleLocationPrerequisite
entryRuleLocationPrerequisite
:
{ before(grammarAccess.getLocationPrerequisiteRule()); }
	 ruleLocationPrerequisite
{ after(grammarAccess.getLocationPrerequisiteRule()); } 
	 EOF 
;

// Rule LocationPrerequisite
ruleLocationPrerequisite 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getLocationPrerequisiteAccess().getGroup()); }
		(rule__LocationPrerequisite__Group__0)
		{ after(grammarAccess.getLocationPrerequisiteAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleNode
entryRuleNode
:
{ before(grammarAccess.getNodeRule()); }
	 ruleNode
{ after(grammarAccess.getNodeRule()); } 
	 EOF 
;

// Rule Node
ruleNode 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getNodeAccess().getAlternatives()); }
		(rule__Node__Alternatives)
		{ after(grammarAccess.getNodeAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleClaim
entryRuleClaim
:
{ before(grammarAccess.getClaimRule()); }
	 ruleClaim
{ after(grammarAccess.getClaimRule()); } 
	 EOF 
;

// Rule Claim
ruleClaim 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getClaimAccess().getGroup()); }
		(rule__Claim__Group__0)
		{ after(grammarAccess.getClaimAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleRelease
entryRuleRelease
:
{ before(grammarAccess.getReleaseRule()); }
	 ruleRelease
{ after(grammarAccess.getReleaseRule()); } 
	 EOF 
;

// Rule Release
ruleRelease 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getReleaseAccess().getGroup()); }
		(rule__Release__Group__0)
		{ after(grammarAccess.getReleaseAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleRaiseEvent
entryRuleRaiseEvent
:
{ before(grammarAccess.getRaiseEventRule()); }
	 ruleRaiseEvent
{ after(grammarAccess.getRaiseEventRule()); } 
	 EOF 
;

// Rule RaiseEvent
ruleRaiseEvent 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getRaiseEventAccess().getGroup()); }
		(rule__RaiseEvent__Group__0)
		{ after(grammarAccess.getRaiseEventAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleRequireEvent
entryRuleRequireEvent
:
{ before(grammarAccess.getRequireEventRule()); }
	 ruleRequireEvent
{ after(grammarAccess.getRequireEventRule()); } 
	 EOF 
;

// Rule RequireEvent
ruleRequireEvent 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getRequireEventAccess().getGroup()); }
		(rule__RequireEvent__Group__0)
		{ after(grammarAccess.getRequireEventAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleMove
entryRuleMove
:
{ before(grammarAccess.getMoveRule()); }
	 ruleMove
{ after(grammarAccess.getMoveRule()); } 
	 EOF 
;

// Rule Move
ruleMove 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getMoveAccess().getGroup()); }
		(rule__Move__Group__0)
		{ after(grammarAccess.getMoveAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleSimpleAction
entryRuleSimpleAction
:
{ before(grammarAccess.getSimpleActionRule()); }
	 ruleSimpleAction
{ after(grammarAccess.getSimpleActionRule()); } 
	 EOF 
;

// Rule SimpleAction
ruleSimpleAction 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getSimpleActionAccess().getGroup()); }
		(rule__SimpleAction__Group__0)
		{ after(grammarAccess.getSimpleActionAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleTracePoint
entryRuleTracePoint
:
{ before(grammarAccess.getTracePointRule()); }
	 ruleTracePoint
{ after(grammarAccess.getTracePointRule()); } 
	 EOF 
;

// Rule TracePoint
ruleTracePoint 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getTracePointAccess().getGroup()); }
		(rule__TracePoint__Group__0)
		{ after(grammarAccess.getTracePointAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEdges
entryRuleEdges
:
{ before(grammarAccess.getEdgesRule()); }
	 ruleEdges
{ after(grammarAccess.getEdgesRule()); } 
	 EOF 
;

// Rule Edges
ruleEdges 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEdgesAccess().getEdgeParserRuleCall()); }
		ruleEdge
		{ after(grammarAccess.getEdgesAccess().getEdgeParserRuleCall()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEdge
entryRuleEdge
:
{ before(grammarAccess.getEdgeRule()); }
	 ruleEdge
{ after(grammarAccess.getEdgeRule()); } 
	 EOF 
;

// Rule Edge
ruleEdge 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEdgeAccess().getGroup()); }
		(rule__Edge__Group__0)
		{ after(grammarAccess.getEdgeAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleSourceReference
entryRuleSourceReference
:
{ before(grammarAccess.getSourceReferenceRule()); }
	 ruleSourceReference
{ after(grammarAccess.getSourceReferenceRule()); } 
	 EOF 
;

// Rule SourceReference
ruleSourceReference 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getSourceReferenceAccess().getGroup()); }
		(rule__SourceReference__Group__0)
		{ after(grammarAccess.getSourceReferenceAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleDependencyTarget
entryRuleDependencyTarget
:
{ before(grammarAccess.getDependencyTargetRule()); }
	 ruleDependencyTarget
{ after(grammarAccess.getDependencyTargetRule()); } 
	 EOF 
;

// Rule DependencyTarget
ruleDependencyTarget 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getDependencyTargetAccess().getAlternatives()); }
		(rule__DependencyTarget__Alternatives)
		{ after(grammarAccess.getDependencyTargetAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleTargetReference
entryRuleTargetReference
:
{ before(grammarAccess.getTargetReferenceRule()); }
	 ruleTargetReference
{ after(grammarAccess.getTargetReferenceRule()); } 
	 EOF 
;

// Rule TargetReference
ruleTargetReference 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getTargetReferenceAccess().getGroup()); }
		(rule__TargetReference__Group__0)
		{ after(grammarAccess.getTargetReferenceAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEvent
entryRuleEvent
:
{ before(grammarAccess.getEventRule()); }
	 ruleEvent
{ after(grammarAccess.getEventRule()); } 
	 EOF 
;

// Rule Event
ruleEvent 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEventAccess().getGroup()); }
		(rule__Event__Group__0)
		{ after(grammarAccess.getEventAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEventItem
entryRuleEventItem
:
{ before(grammarAccess.getEventItemRule()); }
	 ruleEventItem
{ after(grammarAccess.getEventItemRule()); } 
	 EOF 
;

// Rule EventItem
ruleEventItem 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEventItemAccess().getGroup()); }
		(rule__EventItem__Group__0)
		{ after(grammarAccess.getEventItemAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleIID
entryRuleIID
:
{ before(grammarAccess.getIIDRule()); }
	 ruleIID
{ after(grammarAccess.getIIDRule()); } 
	 EOF 
;

// Rule IID
ruleIID 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getIIDAccess().getAlternatives()); }
		(rule__IID__Alternatives)
		{ after(grammarAccess.getIIDAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEString
entryRuleEString
:
{ before(grammarAccess.getEStringRule()); }
	 ruleEString
{ after(grammarAccess.getEStringRule()); } 
	 EOF 
;

// Rule EString
ruleEString 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEStringAccess().getAlternatives()); }
		(rule__EString__Alternatives)
		{ after(grammarAccess.getEStringAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Rule Scheduling
ruleScheduling
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getSchedulingAccess().getAlternatives()); }
		(rule__Scheduling__Alternatives)
		{ after(grammarAccess.getSchedulingAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivitySet__Alternatives_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getActivitySetAccess().getActivitiesAssignment_2_0()); }
		(rule__ActivitySet__ActivitiesAssignment_2_0)
		{ after(grammarAccess.getActivitySetAccess().getActivitiesAssignment_2_0()); }
	)
	|
	(
		{ before(grammarAccess.getActivitySetAccess().getEventsAssignment_2_1()); }
		(rule__ActivitySet__EventsAssignment_2_1)
		{ after(grammarAccess.getActivitySetAccess().getEventsAssignment_2_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Node__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getNodeAccess().getClaimParserRuleCall_0()); }
		ruleClaim
		{ after(grammarAccess.getNodeAccess().getClaimParserRuleCall_0()); }
	)
	|
	(
		{ before(grammarAccess.getNodeAccess().getReleaseParserRuleCall_1()); }
		ruleRelease
		{ after(grammarAccess.getNodeAccess().getReleaseParserRuleCall_1()); }
	)
	|
	(
		{ before(grammarAccess.getNodeAccess().getSimpleActionParserRuleCall_2()); }
		ruleSimpleAction
		{ after(grammarAccess.getNodeAccess().getSimpleActionParserRuleCall_2()); }
	)
	|
	(
		{ before(grammarAccess.getNodeAccess().getMoveParserRuleCall_3()); }
		ruleMove
		{ after(grammarAccess.getNodeAccess().getMoveParserRuleCall_3()); }
	)
	|
	(
		{ before(grammarAccess.getNodeAccess().getRequireEventParserRuleCall_4()); }
		ruleRequireEvent
		{ after(grammarAccess.getNodeAccess().getRequireEventParserRuleCall_4()); }
	)
	|
	(
		{ before(grammarAccess.getNodeAccess().getRaiseEventParserRuleCall_5()); }
		ruleRaiseEvent
		{ after(grammarAccess.getNodeAccess().getRaiseEventParserRuleCall_5()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__Alternatives_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getClaimAccess().getEntryAssignment_3_0()); }
		(rule__Claim__EntryAssignment_3_0)
		{ after(grammarAccess.getClaimAccess().getEntryAssignment_3_0()); }
	)
	|
	(
		{ before(grammarAccess.getClaimAccess().getGroup_3_1()); }
		(rule__Claim__Group_3_1__0)
		{ after(grammarAccess.getClaimAccess().getGroup_3_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__Alternatives_7
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getClaimAccess().getExitAssignment_7_0()); }
		(rule__Claim__ExitAssignment_7_0)
		{ after(grammarAccess.getClaimAccess().getExitAssignment_7_0()); }
	)
	|
	(
		{ before(grammarAccess.getClaimAccess().getGroup_7_1()); }
		(rule__Claim__Group_7_1__0)
		{ after(grammarAccess.getClaimAccess().getGroup_7_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__Alternatives_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getReleaseAccess().getEntryAssignment_3_0()); }
		(rule__Release__EntryAssignment_3_0)
		{ after(grammarAccess.getReleaseAccess().getEntryAssignment_3_0()); }
	)
	|
	(
		{ before(grammarAccess.getReleaseAccess().getGroup_3_1()); }
		(rule__Release__Group_3_1__0)
		{ after(grammarAccess.getReleaseAccess().getGroup_3_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__Alternatives_6
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getReleaseAccess().getExitAssignment_6_0()); }
		(rule__Release__ExitAssignment_6_0)
		{ after(grammarAccess.getReleaseAccess().getExitAssignment_6_0()); }
	)
	|
	(
		{ before(grammarAccess.getReleaseAccess().getGroup_6_1()); }
		(rule__Release__Group_6_1__0)
		{ after(grammarAccess.getReleaseAccess().getGroup_6_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Alternatives_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMoveAccess().getEntryAssignment_3_0()); }
		(rule__Move__EntryAssignment_3_0)
		{ after(grammarAccess.getMoveAccess().getEntryAssignment_3_0()); }
	)
	|
	(
		{ before(grammarAccess.getMoveAccess().getGroup_3_1()); }
		(rule__Move__Group_3_1__0)
		{ after(grammarAccess.getMoveAccess().getGroup_3_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Alternatives_8
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMoveAccess().getGroup_8_0()); }
		(rule__Move__Group_8_0__0)
		{ after(grammarAccess.getMoveAccess().getGroup_8_0()); }
	)
	|
	(
		{ before(grammarAccess.getMoveAccess().getGroup_8_1()); }
		(rule__Move__Group_8_1__0)
		{ after(grammarAccess.getMoveAccess().getGroup_8_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Alternatives_8_0_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMoveAccess().getPassingAssignment_8_0_0_0()); }
		(rule__Move__PassingAssignment_8_0_0_0)
		{ after(grammarAccess.getMoveAccess().getPassingAssignment_8_0_0_0()); }
	)
	|
	(
		{ before(grammarAccess.getMoveAccess().getToKeyword_8_0_0_1()); }
		'to'
		{ after(grammarAccess.getMoveAccess().getToKeyword_8_0_0_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Alternatives_8_1_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMoveAccess().getContinuingAssignment_8_1_0_0()); }
		(rule__Move__ContinuingAssignment_8_1_0_0)
		{ after(grammarAccess.getMoveAccess().getContinuingAssignment_8_1_0_0()); }
	)
	|
	(
		{ before(grammarAccess.getMoveAccess().getForKeyword_8_1_0_1()); }
		'for'
		{ after(grammarAccess.getMoveAccess().getForKeyword_8_1_0_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Alternatives_11
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMoveAccess().getExitAssignment_11_0()); }
		(rule__Move__ExitAssignment_11_0)
		{ after(grammarAccess.getMoveAccess().getExitAssignment_11_0()); }
	)
	|
	(
		{ before(grammarAccess.getMoveAccess().getGroup_11_1()); }
		(rule__Move__Group_11_1__0)
		{ after(grammarAccess.getMoveAccess().getGroup_11_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Alternatives_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getSimpleActionAccess().getEntryAssignment_3_0()); }
		(rule__SimpleAction__EntryAssignment_3_0)
		{ after(grammarAccess.getSimpleActionAccess().getEntryAssignment_3_0()); }
	)
	|
	(
		{ before(grammarAccess.getSimpleActionAccess().getGroup_3_1()); }
		(rule__SimpleAction__Group_3_1__0)
		{ after(grammarAccess.getSimpleActionAccess().getGroup_3_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Alternatives_7
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getSimpleActionAccess().getExitAssignment_7_0()); }
		(rule__SimpleAction__ExitAssignment_7_0)
		{ after(grammarAccess.getSimpleActionAccess().getExitAssignment_7_0()); }
	)
	|
	(
		{ before(grammarAccess.getSimpleActionAccess().getGroup_7_1()); }
		(rule__SimpleAction__Group_7_1__0)
		{ after(grammarAccess.getSimpleActionAccess().getGroup_7_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__SourceReference__Alternatives_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getSourceReferenceAccess().getNodeAssignment_1_0()); }
		(rule__SourceReference__NodeAssignment_1_0)
		{ after(grammarAccess.getSourceReferenceAccess().getNodeAssignment_1_0()); }
	)
	|
	(
		{ before(grammarAccess.getSourceReferenceAccess().getGroup_1_1()); }
		(rule__SourceReference__Group_1_1__0)
		{ after(grammarAccess.getSourceReferenceAccess().getGroup_1_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__DependencyTarget__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDependencyTargetAccess().getTargetReferenceParserRuleCall_0()); }
		ruleTargetReference
		{ after(grammarAccess.getDependencyTargetAccess().getTargetReferenceParserRuleCall_0()); }
	)
	|
	(
		{ before(grammarAccess.getDependencyTargetAccess().getEdgeParserRuleCall_1()); }
		ruleEdge
		{ after(grammarAccess.getDependencyTargetAccess().getEdgeParserRuleCall_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__TargetReference__Alternatives_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getTargetReferenceAccess().getNodeAssignment_1_0()); }
		(rule__TargetReference__NodeAssignment_1_0)
		{ after(grammarAccess.getTargetReferenceAccess().getNodeAssignment_1_0()); }
	)
	|
	(
		{ before(grammarAccess.getTargetReferenceAccess().getGroup_1_1()); }
		(rule__TargetReference__Group_1_1__0)
		{ after(grammarAccess.getTargetReferenceAccess().getGroup_1_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__IID__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getIIDAccess().getINTTerminalRuleCall_0()); }
		RULE_INT
		{ after(grammarAccess.getIIDAccess().getINTTerminalRuleCall_0()); }
	)
	|
	(
		{ before(grammarAccess.getIIDAccess().getIDTerminalRuleCall_1()); }
		RULE_ID
		{ after(grammarAccess.getIIDAccess().getIDTerminalRuleCall_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EString__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEStringAccess().getSTRINGTerminalRuleCall_0()); }
		RULE_STRING
		{ after(grammarAccess.getEStringAccess().getSTRINGTerminalRuleCall_0()); }
	)
	|
	(
		{ before(grammarAccess.getEStringAccess().getIDTerminalRuleCall_1()); }
		RULE_ID
		{ after(grammarAccess.getEStringAccess().getIDTerminalRuleCall_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Scheduling__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getSchedulingAccess().getASAPEnumLiteralDeclaration_0()); }
		('ASAP')
		{ after(grammarAccess.getSchedulingAccess().getASAPEnumLiteralDeclaration_0()); }
	)
	|
	(
		{ before(grammarAccess.getSchedulingAccess().getALAPEnumLiteralDeclaration_1()); }
		('ALAP')
		{ after(grammarAccess.getSchedulingAccess().getALAPEnumLiteralDeclaration_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivitySet__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ActivitySet__Group__0__Impl
	rule__ActivitySet__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivitySet__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivitySetAccess().getActivitySetAction_0()); }
	()
	{ after(grammarAccess.getActivitySetAccess().getActivitySetAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivitySet__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ActivitySet__Group__1__Impl
	rule__ActivitySet__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivitySet__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivitySetAccess().getImportsAssignment_1()); }
	(rule__ActivitySet__ImportsAssignment_1)*
	{ after(grammarAccess.getActivitySetAccess().getImportsAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivitySet__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ActivitySet__Group__2__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivitySet__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivitySetAccess().getAlternatives_2()); }
	(rule__ActivitySet__Alternatives_2)*
	{ after(grammarAccess.getActivitySetAccess().getAlternatives_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Import__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Import__Group__0__Impl
	rule__Import__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Import__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getImportAccess().getImportKeyword_0()); }
	'import'
	{ after(grammarAccess.getImportAccess().getImportKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Import__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Import__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Import__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getImportAccess().getImportURIAssignment_1()); }
	(rule__Import__ImportURIAssignment_1)
	{ after(grammarAccess.getImportAccess().getImportURIAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Activity__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Activity__Group__0__Impl
	rule__Activity__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityAccess().getActivityKeyword_0()); }
	'activity'
	{ after(grammarAccess.getActivityAccess().getActivityKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Activity__Group__1__Impl
	rule__Activity__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityAccess().getNameAssignment_1()); }
	(rule__Activity__NameAssignment_1)
	{ after(grammarAccess.getActivityAccess().getNameAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Activity__Group__2__Impl
	rule__Activity__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityAccess().getLeftCurlyBracketKeyword_2()); }
	'{'
	{ after(grammarAccess.getActivityAccess().getLeftCurlyBracketKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Activity__Group__3__Impl
	rule__Activity__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityAccess().getGroup_3()); }
	(rule__Activity__Group_3__0)?
	{ after(grammarAccess.getActivityAccess().getGroup_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Activity__Group__4__Impl
	rule__Activity__Group__5
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityAccess().getActionsKeyword_4()); }
	'actions'
	{ after(grammarAccess.getActivityAccess().getActionsKeyword_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Activity__Group__5__Impl
	rule__Activity__Group__6
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityAccess().getLeftCurlyBracketKeyword_5()); }
	'{'
	{ after(grammarAccess.getActivityAccess().getLeftCurlyBracketKeyword_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__6
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Activity__Group__6__Impl
	rule__Activity__Group__7
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__6__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityAccess().getNodesAssignment_6()); }
	(rule__Activity__NodesAssignment_6)*
	{ after(grammarAccess.getActivityAccess().getNodesAssignment_6()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__7
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Activity__Group__7__Impl
	rule__Activity__Group__8
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__7__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityAccess().getRightCurlyBracketKeyword_7()); }
	'}'
	{ after(grammarAccess.getActivityAccess().getRightCurlyBracketKeyword_7()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__8
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Activity__Group__8__Impl
	rule__Activity__Group__9
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__8__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityAccess().getActionFlowKeyword_8()); }
	'action flow'
	{ after(grammarAccess.getActivityAccess().getActionFlowKeyword_8()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__9
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Activity__Group__9__Impl
	rule__Activity__Group__10
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__9__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityAccess().getLeftCurlyBracketKeyword_9()); }
	'{'
	{ after(grammarAccess.getActivityAccess().getLeftCurlyBracketKeyword_9()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__10
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Activity__Group__10__Impl
	rule__Activity__Group__11
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__10__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityAccess().getEdgesAssignment_10()); }
	(rule__Activity__EdgesAssignment_10)*
	{ after(grammarAccess.getActivityAccess().getEdgesAssignment_10()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__11
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Activity__Group__11__Impl
	rule__Activity__Group__12
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__11__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityAccess().getRightCurlyBracketKeyword_11()); }
	'}'
	{ after(grammarAccess.getActivityAccess().getRightCurlyBracketKeyword_11()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__12
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Activity__Group__12__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group__12__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityAccess().getRightCurlyBracketKeyword_12()); }
	'}'
	{ after(grammarAccess.getActivityAccess().getRightCurlyBracketKeyword_12()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Activity__Group_3__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Activity__Group_3__0__Impl
	rule__Activity__Group_3__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group_3__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityAccess().getPrerequisitesKeyword_3_0()); }
	'prerequisites'
	{ after(grammarAccess.getActivityAccess().getPrerequisitesKeyword_3_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group_3__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Activity__Group_3__1__Impl
	rule__Activity__Group_3__2
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group_3__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityAccess().getLeftCurlyBracketKeyword_3_1()); }
	'{'
	{ after(grammarAccess.getActivityAccess().getLeftCurlyBracketKeyword_3_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group_3__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Activity__Group_3__2__Impl
	rule__Activity__Group_3__3
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group_3__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityAccess().getPrerequisitesAssignment_3_2()); }
	(rule__Activity__PrerequisitesAssignment_3_2)*
	{ after(grammarAccess.getActivityAccess().getPrerequisitesAssignment_3_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group_3__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Activity__Group_3__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__Group_3__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityAccess().getRightCurlyBracketKeyword_3_3()); }
	'}'
	{ after(grammarAccess.getActivityAccess().getRightCurlyBracketKeyword_3_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__ResourceQualifiedName__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceQualifiedName__Group__0__Impl
	rule__ResourceQualifiedName__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceQualifiedName__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceQualifiedNameAccess().getIIDParserRuleCall_0()); }
	ruleIID
	{ after(grammarAccess.getResourceQualifiedNameAccess().getIIDParserRuleCall_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceQualifiedName__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceQualifiedName__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceQualifiedName__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceQualifiedNameAccess().getGroup_1()); }
	(rule__ResourceQualifiedName__Group_1__0)?
	{ after(grammarAccess.getResourceQualifiedNameAccess().getGroup_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__ResourceQualifiedName__Group_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceQualifiedName__Group_1__0__Impl
	rule__ResourceQualifiedName__Group_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceQualifiedName__Group_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceQualifiedNameAccess().getFullStopKeyword_1_0()); }
	'.'
	{ after(grammarAccess.getResourceQualifiedNameAccess().getFullStopKeyword_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceQualifiedName__Group_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceQualifiedName__Group_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceQualifiedName__Group_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceQualifiedNameAccess().getIIDParserRuleCall_1_1()); }
	ruleIID
	{ after(grammarAccess.getResourceQualifiedNameAccess().getIIDParserRuleCall_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__LocationPrerequisite__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__LocationPrerequisite__Group__0__Impl
	rule__LocationPrerequisite__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__LocationPrerequisite__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getLocationPrerequisiteAccess().getResourceAssignment_0()); }
	(rule__LocationPrerequisite__ResourceAssignment_0)
	{ after(grammarAccess.getLocationPrerequisiteAccess().getResourceAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__LocationPrerequisite__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__LocationPrerequisite__Group__1__Impl
	rule__LocationPrerequisite__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__LocationPrerequisite__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getLocationPrerequisiteAccess().getFullStopKeyword_1()); }
	'.'
	{ after(grammarAccess.getLocationPrerequisiteAccess().getFullStopKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__LocationPrerequisite__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__LocationPrerequisite__Group__2__Impl
	rule__LocationPrerequisite__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__LocationPrerequisite__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getLocationPrerequisiteAccess().getPeripheralAssignment_2()); }
	(rule__LocationPrerequisite__PeripheralAssignment_2)
	{ after(grammarAccess.getLocationPrerequisiteAccess().getPeripheralAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__LocationPrerequisite__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__LocationPrerequisite__Group__3__Impl
	rule__LocationPrerequisite__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__LocationPrerequisite__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getLocationPrerequisiteAccess().getAtKeyword_3()); }
	'at'
	{ after(grammarAccess.getLocationPrerequisiteAccess().getAtKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__LocationPrerequisite__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__LocationPrerequisite__Group__4__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__LocationPrerequisite__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getLocationPrerequisiteAccess().getPositionAssignment_4()); }
	(rule__LocationPrerequisite__PositionAssignment_4)
	{ after(grammarAccess.getLocationPrerequisiteAccess().getPositionAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Claim__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Claim__Group__0__Impl
	rule__Claim__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getClaimAccess().getClaimAction_0()); }
	()
	{ after(grammarAccess.getClaimAccess().getClaimAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Claim__Group__1__Impl
	rule__Claim__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getClaimAccess().getNameAssignment_1()); }
	(rule__Claim__NameAssignment_1)
	{ after(grammarAccess.getClaimAccess().getNameAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Claim__Group__2__Impl
	rule__Claim__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getClaimAccess().getColonKeyword_2()); }
	':'
	{ after(grammarAccess.getClaimAccess().getColonKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Claim__Group__3__Impl
	rule__Claim__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getClaimAccess().getAlternatives_3()); }
	(rule__Claim__Alternatives_3)?
	{ after(grammarAccess.getClaimAccess().getAlternatives_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Claim__Group__4__Impl
	rule__Claim__Group__5
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getClaimAccess().getPassiveAssignment_4()); }
	(rule__Claim__PassiveAssignment_4)?
	{ after(grammarAccess.getClaimAccess().getPassiveAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__Group__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Claim__Group__5__Impl
	rule__Claim__Group__6
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__Group__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getClaimAccess().getClaimKeyword_5()); }
	'claim'
	{ after(grammarAccess.getClaimAccess().getClaimKeyword_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__Group__6
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Claim__Group__6__Impl
	rule__Claim__Group__7
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__Group__6__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getClaimAccess().getResourceAssignment_6()); }
	(rule__Claim__ResourceAssignment_6)
	{ after(grammarAccess.getClaimAccess().getResourceAssignment_6()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__Group__7
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Claim__Group__7__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__Group__7__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getClaimAccess().getAlternatives_7()); }
	(rule__Claim__Alternatives_7)?
	{ after(grammarAccess.getClaimAccess().getAlternatives_7()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Claim__Group_3_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Claim__Group_3_1__0__Impl
	rule__Claim__Group_3_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__Group_3_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getClaimAccess().getOuterEntryAssignment_3_1_0()); }
	(rule__Claim__OuterEntryAssignment_3_1_0)
	{ after(grammarAccess.getClaimAccess().getOuterEntryAssignment_3_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__Group_3_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Claim__Group_3_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__Group_3_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getClaimAccess().getEntryAssignment_3_1_1()); }
	(rule__Claim__EntryAssignment_3_1_1)
	{ after(grammarAccess.getClaimAccess().getEntryAssignment_3_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Claim__Group_7_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Claim__Group_7_1__0__Impl
	rule__Claim__Group_7_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__Group_7_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getClaimAccess().getExitAssignment_7_1_0()); }
	(rule__Claim__ExitAssignment_7_1_0)
	{ after(grammarAccess.getClaimAccess().getExitAssignment_7_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__Group_7_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Claim__Group_7_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__Group_7_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getClaimAccess().getOuterExitAssignment_7_1_1()); }
	(rule__Claim__OuterExitAssignment_7_1_1)
	{ after(grammarAccess.getClaimAccess().getOuterExitAssignment_7_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Release__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Release__Group__0__Impl
	rule__Release__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getReleaseAccess().getReleaseAction_0()); }
	()
	{ after(grammarAccess.getReleaseAccess().getReleaseAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Release__Group__1__Impl
	rule__Release__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getReleaseAccess().getNameAssignment_1()); }
	(rule__Release__NameAssignment_1)
	{ after(grammarAccess.getReleaseAccess().getNameAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Release__Group__2__Impl
	rule__Release__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getReleaseAccess().getColonKeyword_2()); }
	':'
	{ after(grammarAccess.getReleaseAccess().getColonKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Release__Group__3__Impl
	rule__Release__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getReleaseAccess().getAlternatives_3()); }
	(rule__Release__Alternatives_3)?
	{ after(grammarAccess.getReleaseAccess().getAlternatives_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Release__Group__4__Impl
	rule__Release__Group__5
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getReleaseAccess().getReleaseKeyword_4()); }
	'release'
	{ after(grammarAccess.getReleaseAccess().getReleaseKeyword_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__Group__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Release__Group__5__Impl
	rule__Release__Group__6
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__Group__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getReleaseAccess().getResourceAssignment_5()); }
	(rule__Release__ResourceAssignment_5)
	{ after(grammarAccess.getReleaseAccess().getResourceAssignment_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__Group__6
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Release__Group__6__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__Group__6__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getReleaseAccess().getAlternatives_6()); }
	(rule__Release__Alternatives_6)?
	{ after(grammarAccess.getReleaseAccess().getAlternatives_6()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Release__Group_3_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Release__Group_3_1__0__Impl
	rule__Release__Group_3_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__Group_3_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getReleaseAccess().getOuterEntryAssignment_3_1_0()); }
	(rule__Release__OuterEntryAssignment_3_1_0)
	{ after(grammarAccess.getReleaseAccess().getOuterEntryAssignment_3_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__Group_3_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Release__Group_3_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__Group_3_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getReleaseAccess().getEntryAssignment_3_1_1()); }
	(rule__Release__EntryAssignment_3_1_1)
	{ after(grammarAccess.getReleaseAccess().getEntryAssignment_3_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Release__Group_6_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Release__Group_6_1__0__Impl
	rule__Release__Group_6_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__Group_6_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getReleaseAccess().getExitAssignment_6_1_0()); }
	(rule__Release__ExitAssignment_6_1_0)
	{ after(grammarAccess.getReleaseAccess().getExitAssignment_6_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__Group_6_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Release__Group_6_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__Group_6_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getReleaseAccess().getOuterExitAssignment_6_1_1()); }
	(rule__Release__OuterExitAssignment_6_1_1)
	{ after(grammarAccess.getReleaseAccess().getOuterExitAssignment_6_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__RaiseEvent__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__RaiseEvent__Group__0__Impl
	rule__RaiseEvent__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__RaiseEvent__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getRaiseEventAccess().getRaiseEventAction_0()); }
	()
	{ after(grammarAccess.getRaiseEventAccess().getRaiseEventAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__RaiseEvent__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__RaiseEvent__Group__1__Impl
	rule__RaiseEvent__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__RaiseEvent__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getRaiseEventAccess().getNameAssignment_1()); }
	(rule__RaiseEvent__NameAssignment_1)
	{ after(grammarAccess.getRaiseEventAccess().getNameAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__RaiseEvent__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__RaiseEvent__Group__2__Impl
	rule__RaiseEvent__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__RaiseEvent__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getRaiseEventAccess().getColonKeyword_2()); }
	':'
	{ after(grammarAccess.getRaiseEventAccess().getColonKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__RaiseEvent__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__RaiseEvent__Group__3__Impl
	rule__RaiseEvent__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__RaiseEvent__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getRaiseEventAccess().getRaiseKeyword_3()); }
	'raise'
	{ after(grammarAccess.getRaiseEventAccess().getRaiseKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__RaiseEvent__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__RaiseEvent__Group__4__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__RaiseEvent__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getRaiseEventAccess().getResourceAssignment_4()); }
	(rule__RaiseEvent__ResourceAssignment_4)
	{ after(grammarAccess.getRaiseEventAccess().getResourceAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__RequireEvent__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__RequireEvent__Group__0__Impl
	rule__RequireEvent__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__RequireEvent__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getRequireEventAccess().getRequireEventAction_0()); }
	()
	{ after(grammarAccess.getRequireEventAccess().getRequireEventAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__RequireEvent__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__RequireEvent__Group__1__Impl
	rule__RequireEvent__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__RequireEvent__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getRequireEventAccess().getNameAssignment_1()); }
	(rule__RequireEvent__NameAssignment_1)
	{ after(grammarAccess.getRequireEventAccess().getNameAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__RequireEvent__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__RequireEvent__Group__2__Impl
	rule__RequireEvent__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__RequireEvent__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getRequireEventAccess().getColonKeyword_2()); }
	':'
	{ after(grammarAccess.getRequireEventAccess().getColonKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__RequireEvent__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__RequireEvent__Group__3__Impl
	rule__RequireEvent__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__RequireEvent__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getRequireEventAccess().getRequireKeyword_3()); }
	'require'
	{ after(grammarAccess.getRequireEventAccess().getRequireKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__RequireEvent__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__RequireEvent__Group__4__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__RequireEvent__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getRequireEventAccess().getResourceAssignment_4()); }
	(rule__RequireEvent__ResourceAssignment_4)
	{ after(grammarAccess.getRequireEventAccess().getResourceAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Move__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Move__Group__0__Impl
	rule__Move__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMoveAccess().getMoveAction_0()); }
	()
	{ after(grammarAccess.getMoveAccess().getMoveAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Move__Group__1__Impl
	rule__Move__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMoveAccess().getNameAssignment_1()); }
	(rule__Move__NameAssignment_1)
	{ after(grammarAccess.getMoveAccess().getNameAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Move__Group__2__Impl
	rule__Move__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMoveAccess().getColonKeyword_2()); }
	':'
	{ after(grammarAccess.getMoveAccess().getColonKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Move__Group__3__Impl
	rule__Move__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMoveAccess().getAlternatives_3()); }
	(rule__Move__Alternatives_3)?
	{ after(grammarAccess.getMoveAccess().getAlternatives_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Move__Group__4__Impl
	rule__Move__Group__5
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMoveAccess().getMoveKeyword_4()); }
	'move'
	{ after(grammarAccess.getMoveAccess().getMoveKeyword_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Move__Group__5__Impl
	rule__Move__Group__6
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMoveAccess().getResourceAssignment_5()); }
	(rule__Move__ResourceAssignment_5)
	{ after(grammarAccess.getMoveAccess().getResourceAssignment_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group__6
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Move__Group__6__Impl
	rule__Move__Group__7
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group__6__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMoveAccess().getFullStopKeyword_6()); }
	'.'
	{ after(grammarAccess.getMoveAccess().getFullStopKeyword_6()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group__7
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Move__Group__7__Impl
	rule__Move__Group__8
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group__7__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMoveAccess().getPeripheralAssignment_7()); }
	(rule__Move__PeripheralAssignment_7)
	{ after(grammarAccess.getMoveAccess().getPeripheralAssignment_7()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group__8
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Move__Group__8__Impl
	rule__Move__Group__9
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group__8__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMoveAccess().getAlternatives_8()); }
	(rule__Move__Alternatives_8)
	{ after(grammarAccess.getMoveAccess().getAlternatives_8()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group__9
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Move__Group__9__Impl
	rule__Move__Group__10
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group__9__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMoveAccess().getGroup_9()); }
	(rule__Move__Group_9__0)
	{ after(grammarAccess.getMoveAccess().getGroup_9()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group__10
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Move__Group__10__Impl
	rule__Move__Group__11
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group__10__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMoveAccess().getSchedulingTypeAssignment_10()); }
	(rule__Move__SchedulingTypeAssignment_10)?
	{ after(grammarAccess.getMoveAccess().getSchedulingTypeAssignment_10()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group__11
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Move__Group__11__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group__11__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMoveAccess().getAlternatives_11()); }
	(rule__Move__Alternatives_11)?
	{ after(grammarAccess.getMoveAccess().getAlternatives_11()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Move__Group_3_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Move__Group_3_1__0__Impl
	rule__Move__Group_3_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group_3_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMoveAccess().getOuterEntryAssignment_3_1_0()); }
	(rule__Move__OuterEntryAssignment_3_1_0)
	{ after(grammarAccess.getMoveAccess().getOuterEntryAssignment_3_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group_3_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Move__Group_3_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group_3_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMoveAccess().getEntryAssignment_3_1_1()); }
	(rule__Move__EntryAssignment_3_1_1)
	{ after(grammarAccess.getMoveAccess().getEntryAssignment_3_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Move__Group_8_0__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Move__Group_8_0__0__Impl
	rule__Move__Group_8_0__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group_8_0__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMoveAccess().getAlternatives_8_0_0()); }
	(rule__Move__Alternatives_8_0_0)
	{ after(grammarAccess.getMoveAccess().getAlternatives_8_0_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group_8_0__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Move__Group_8_0__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group_8_0__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMoveAccess().getTargetPositionAssignment_8_0_1()); }
	(rule__Move__TargetPositionAssignment_8_0_1)
	{ after(grammarAccess.getMoveAccess().getTargetPositionAssignment_8_0_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Move__Group_8_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Move__Group_8_1__0__Impl
	rule__Move__Group_8_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group_8_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMoveAccess().getAlternatives_8_1_0()); }
	(rule__Move__Alternatives_8_1_0)
	{ after(grammarAccess.getMoveAccess().getAlternatives_8_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group_8_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Move__Group_8_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group_8_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMoveAccess().getDistanceAssignment_8_1_1()); }
	(rule__Move__DistanceAssignment_8_1_1)
	{ after(grammarAccess.getMoveAccess().getDistanceAssignment_8_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Move__Group_9__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Move__Group_9__0__Impl
	rule__Move__Group_9__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group_9__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMoveAccess().getWithSpeedProfileKeyword_9_0()); }
	'with speed profile'
	{ after(grammarAccess.getMoveAccess().getWithSpeedProfileKeyword_9_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group_9__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Move__Group_9__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group_9__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMoveAccess().getProfileAssignment_9_1()); }
	(rule__Move__ProfileAssignment_9_1)
	{ after(grammarAccess.getMoveAccess().getProfileAssignment_9_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Move__Group_11_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Move__Group_11_1__0__Impl
	rule__Move__Group_11_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group_11_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMoveAccess().getExitAssignment_11_1_0()); }
	(rule__Move__ExitAssignment_11_1_0)
	{ after(grammarAccess.getMoveAccess().getExitAssignment_11_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group_11_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Move__Group_11_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__Group_11_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getMoveAccess().getOuterExitAssignment_11_1_1()); }
	(rule__Move__OuterExitAssignment_11_1_1)
	{ after(grammarAccess.getMoveAccess().getOuterExitAssignment_11_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__SimpleAction__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__SimpleAction__Group__0__Impl
	rule__SimpleAction__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSimpleActionAccess().getSimpleActionAction_0()); }
	()
	{ after(grammarAccess.getSimpleActionAccess().getSimpleActionAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__SimpleAction__Group__1__Impl
	rule__SimpleAction__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSimpleActionAccess().getNameAssignment_1()); }
	(rule__SimpleAction__NameAssignment_1)
	{ after(grammarAccess.getSimpleActionAccess().getNameAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__SimpleAction__Group__2__Impl
	rule__SimpleAction__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSimpleActionAccess().getColonKeyword_2()); }
	':'
	{ after(grammarAccess.getSimpleActionAccess().getColonKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__SimpleAction__Group__3__Impl
	rule__SimpleAction__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSimpleActionAccess().getAlternatives_3()); }
	(rule__SimpleAction__Alternatives_3)?
	{ after(grammarAccess.getSimpleActionAccess().getAlternatives_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__SimpleAction__Group__4__Impl
	rule__SimpleAction__Group__5
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSimpleActionAccess().getResourceAssignment_4()); }
	(rule__SimpleAction__ResourceAssignment_4)
	{ after(grammarAccess.getSimpleActionAccess().getResourceAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__SimpleAction__Group__5__Impl
	rule__SimpleAction__Group__6
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSimpleActionAccess().getGroup_5()); }
	(rule__SimpleAction__Group_5__0)
	{ after(grammarAccess.getSimpleActionAccess().getGroup_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group__6
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__SimpleAction__Group__6__Impl
	rule__SimpleAction__Group__7
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group__6__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSimpleActionAccess().getSchedulingTypeAssignment_6()); }
	(rule__SimpleAction__SchedulingTypeAssignment_6)?
	{ after(grammarAccess.getSimpleActionAccess().getSchedulingTypeAssignment_6()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group__7
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__SimpleAction__Group__7__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group__7__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSimpleActionAccess().getAlternatives_7()); }
	(rule__SimpleAction__Alternatives_7)?
	{ after(grammarAccess.getSimpleActionAccess().getAlternatives_7()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__SimpleAction__Group_3_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__SimpleAction__Group_3_1__0__Impl
	rule__SimpleAction__Group_3_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group_3_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSimpleActionAccess().getOuterEntryAssignment_3_1_0()); }
	(rule__SimpleAction__OuterEntryAssignment_3_1_0)
	{ after(grammarAccess.getSimpleActionAccess().getOuterEntryAssignment_3_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group_3_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__SimpleAction__Group_3_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group_3_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSimpleActionAccess().getEntryAssignment_3_1_1()); }
	(rule__SimpleAction__EntryAssignment_3_1_1)
	{ after(grammarAccess.getSimpleActionAccess().getEntryAssignment_3_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__SimpleAction__Group_5__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__SimpleAction__Group_5__0__Impl
	rule__SimpleAction__Group_5__1
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group_5__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSimpleActionAccess().getFullStopKeyword_5_0()); }
	('.')
	{ after(grammarAccess.getSimpleActionAccess().getFullStopKeyword_5_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group_5__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__SimpleAction__Group_5__1__Impl
	rule__SimpleAction__Group_5__2
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group_5__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSimpleActionAccess().getPeripheralAssignment_5_1()); }
	(rule__SimpleAction__PeripheralAssignment_5_1)
	{ after(grammarAccess.getSimpleActionAccess().getPeripheralAssignment_5_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group_5__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__SimpleAction__Group_5__2__Impl
	rule__SimpleAction__Group_5__3
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group_5__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSimpleActionAccess().getFullStopKeyword_5_2()); }
	'.'
	{ after(grammarAccess.getSimpleActionAccess().getFullStopKeyword_5_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group_5__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__SimpleAction__Group_5__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group_5__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSimpleActionAccess().getTypeAssignment_5_3()); }
	(rule__SimpleAction__TypeAssignment_5_3)
	{ after(grammarAccess.getSimpleActionAccess().getTypeAssignment_5_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__SimpleAction__Group_7_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__SimpleAction__Group_7_1__0__Impl
	rule__SimpleAction__Group_7_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group_7_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSimpleActionAccess().getExitAssignment_7_1_0()); }
	(rule__SimpleAction__ExitAssignment_7_1_0)
	{ after(grammarAccess.getSimpleActionAccess().getExitAssignment_7_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group_7_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__SimpleAction__Group_7_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__Group_7_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSimpleActionAccess().getOuterExitAssignment_7_1_1()); }
	(rule__SimpleAction__OuterExitAssignment_7_1_1)
	{ after(grammarAccess.getSimpleActionAccess().getOuterExitAssignment_7_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__TracePoint__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TracePoint__Group__0__Impl
	rule__TracePoint__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__TracePoint__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTracePointAccess().getLeftSquareBracketKeyword_0()); }
	'['
	{ after(grammarAccess.getTracePointAccess().getLeftSquareBracketKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TracePoint__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TracePoint__Group__1__Impl
	rule__TracePoint__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__TracePoint__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTracePointAccess().getRegexAssignment_1()); }
	(rule__TracePoint__RegexAssignment_1)?
	{ after(grammarAccess.getTracePointAccess().getRegexAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TracePoint__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TracePoint__Group__2__Impl
	rule__TracePoint__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__TracePoint__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTracePointAccess().getValueAssignment_2()); }
	(rule__TracePoint__ValueAssignment_2)
	{ after(grammarAccess.getTracePointAccess().getValueAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TracePoint__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TracePoint__Group__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__TracePoint__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTracePointAccess().getRightSquareBracketKeyword_3()); }
	']'
	{ after(grammarAccess.getTracePointAccess().getRightSquareBracketKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Edge__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Edge__Group__0__Impl
	rule__Edge__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Edge__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEdgeAccess().getEdgeAction_0()); }
	()
	{ after(grammarAccess.getEdgeAccess().getEdgeAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Edge__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Edge__Group__1__Impl
	rule__Edge__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__Edge__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEdgeAccess().getSourceAssignment_1()); }
	(rule__Edge__SourceAssignment_1)
	{ after(grammarAccess.getEdgeAccess().getSourceAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Edge__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Edge__Group__2__Impl
	rule__Edge__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__Edge__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEdgeAccess().getHyphenMinusGreaterThanSignKeyword_2()); }
	'->'
	{ after(grammarAccess.getEdgeAccess().getHyphenMinusGreaterThanSignKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Edge__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Edge__Group__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Edge__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEdgeAccess().getTargetAssignment_3()); }
	(rule__Edge__TargetAssignment_3)
	{ after(grammarAccess.getEdgeAccess().getTargetAssignment_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__SourceReference__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__SourceReference__Group__0__Impl
	rule__SourceReference__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__SourceReference__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSourceReferenceAccess().getSourceReferenceAction_0()); }
	()
	{ after(grammarAccess.getSourceReferenceAccess().getSourceReferenceAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__SourceReference__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__SourceReference__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__SourceReference__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSourceReferenceAccess().getAlternatives_1()); }
	(rule__SourceReference__Alternatives_1)
	{ after(grammarAccess.getSourceReferenceAccess().getAlternatives_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__SourceReference__Group_1_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__SourceReference__Group_1_1__0__Impl
	rule__SourceReference__Group_1_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__SourceReference__Group_1_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSourceReferenceAccess().getVerticalLineKeyword_1_1_0()); }
	'|'
	{ after(grammarAccess.getSourceReferenceAccess().getVerticalLineKeyword_1_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__SourceReference__Group_1_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__SourceReference__Group_1_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__SourceReference__Group_1_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getSourceReferenceAccess().getNodeAssignment_1_1_1()); }
	(rule__SourceReference__NodeAssignment_1_1_1)
	{ after(grammarAccess.getSourceReferenceAccess().getNodeAssignment_1_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__TargetReference__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TargetReference__Group__0__Impl
	rule__TargetReference__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__TargetReference__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTargetReferenceAccess().getTargetReferenceAction_0()); }
	()
	{ after(grammarAccess.getTargetReferenceAccess().getTargetReferenceAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TargetReference__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TargetReference__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__TargetReference__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTargetReferenceAccess().getAlternatives_1()); }
	(rule__TargetReference__Alternatives_1)
	{ after(grammarAccess.getTargetReferenceAccess().getAlternatives_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__TargetReference__Group_1_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TargetReference__Group_1_1__0__Impl
	rule__TargetReference__Group_1_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__TargetReference__Group_1_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTargetReferenceAccess().getVerticalLineKeyword_1_1_0()); }
	'|'
	{ after(grammarAccess.getTargetReferenceAccess().getVerticalLineKeyword_1_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__TargetReference__Group_1_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__TargetReference__Group_1_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__TargetReference__Group_1_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getTargetReferenceAccess().getNodeAssignment_1_1_1()); }
	(rule__TargetReference__NodeAssignment_1_1_1)
	{ after(grammarAccess.getTargetReferenceAccess().getNodeAssignment_1_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Event__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Event__Group__0__Impl
	rule__Event__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Event__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEventAccess().getEventKeyword_0()); }
	'event'
	{ after(grammarAccess.getEventAccess().getEventKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Event__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Event__Group__1__Impl
	rule__Event__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__Event__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEventAccess().getNameAssignment_1()); }
	(rule__Event__NameAssignment_1)
	{ after(grammarAccess.getEventAccess().getNameAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Event__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Event__Group__2__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Event__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEventAccess().getGroup_2()); }
	(rule__Event__Group_2__0)?
	{ after(grammarAccess.getEventAccess().getGroup_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Event__Group_2__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Event__Group_2__0__Impl
	rule__Event__Group_2__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Event__Group_2__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEventAccess().getLeftParenthesisKeyword_2_0()); }
	'('
	{ after(grammarAccess.getEventAccess().getLeftParenthesisKeyword_2_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Event__Group_2__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Event__Group_2__1__Impl
	rule__Event__Group_2__2
;
finally {
	restoreStackSize(stackSize);
}

rule__Event__Group_2__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEventAccess().getItemsAssignment_2_1()); }
	(rule__Event__ItemsAssignment_2_1)
	{ after(grammarAccess.getEventAccess().getItemsAssignment_2_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Event__Group_2__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Event__Group_2__2__Impl
	rule__Event__Group_2__3
;
finally {
	restoreStackSize(stackSize);
}

rule__Event__Group_2__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEventAccess().getGroup_2_2()); }
	(rule__Event__Group_2_2__0)*
	{ after(grammarAccess.getEventAccess().getGroup_2_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Event__Group_2__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Event__Group_2__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Event__Group_2__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEventAccess().getRightParenthesisKeyword_2_3()); }
	')'
	{ after(grammarAccess.getEventAccess().getRightParenthesisKeyword_2_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Event__Group_2_2__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Event__Group_2_2__0__Impl
	rule__Event__Group_2_2__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Event__Group_2_2__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEventAccess().getCommaKeyword_2_2_0()); }
	','
	{ after(grammarAccess.getEventAccess().getCommaKeyword_2_2_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Event__Group_2_2__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Event__Group_2_2__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Event__Group_2_2__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEventAccess().getItemsAssignment_2_2_1()); }
	(rule__Event__ItemsAssignment_2_2_1)
	{ after(grammarAccess.getEventAccess().getItemsAssignment_2_2_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EventItem__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EventItem__Group__0__Impl
	rule__EventItem__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EventItem__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEventItemAccess().getEventItemAction_0()); }
	()
	{ after(grammarAccess.getEventItemAccess().getEventItemAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EventItem__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EventItem__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EventItem__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEventItemAccess().getNameAssignment_1()); }
	(rule__EventItem__NameAssignment_1)
	{ after(grammarAccess.getEventItemAccess().getNameAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__ActivitySet__ImportsAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getActivitySetAccess().getImportsImportParserRuleCall_1_0()); }
		ruleImport
		{ after(grammarAccess.getActivitySetAccess().getImportsImportParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivitySet__ActivitiesAssignment_2_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getActivitySetAccess().getActivitiesActivityParserRuleCall_2_0_0()); }
		ruleActivity
		{ after(grammarAccess.getActivitySetAccess().getActivitiesActivityParserRuleCall_2_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivitySet__EventsAssignment_2_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getActivitySetAccess().getEventsEventParserRuleCall_2_1_0()); }
		ruleEvent
		{ after(grammarAccess.getActivitySetAccess().getEventsEventParserRuleCall_2_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Import__ImportURIAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getImportAccess().getImportURISTRINGTerminalRuleCall_1_0()); }
		RULE_STRING
		{ after(grammarAccess.getImportAccess().getImportURISTRINGTerminalRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__NameAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getActivityAccess().getNameIIDParserRuleCall_1_0()); }
		ruleIID
		{ after(grammarAccess.getActivityAccess().getNameIIDParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__PrerequisitesAssignment_3_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getActivityAccess().getPrerequisitesLocationPrerequisiteParserRuleCall_3_2_0()); }
		ruleLocationPrerequisite
		{ after(grammarAccess.getActivityAccess().getPrerequisitesLocationPrerequisiteParserRuleCall_3_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__NodesAssignment_6
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getActivityAccess().getNodesNodeParserRuleCall_6_0()); }
		ruleNode
		{ after(grammarAccess.getActivityAccess().getNodesNodeParserRuleCall_6_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Activity__EdgesAssignment_10
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getActivityAccess().getEdgesEdgesParserRuleCall_10_0()); }
		ruleEdges
		{ after(grammarAccess.getActivityAccess().getEdgesEdgesParserRuleCall_10_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__LocationPrerequisite__ResourceAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getLocationPrerequisiteAccess().getResourceIResourceCrossReference_0_0()); }
		(
			{ before(grammarAccess.getLocationPrerequisiteAccess().getResourceIResourceResourceQualifiedNameParserRuleCall_0_0_1()); }
			ruleResourceQualifiedName
			{ after(grammarAccess.getLocationPrerequisiteAccess().getResourceIResourceResourceQualifiedNameParserRuleCall_0_0_1()); }
		)
		{ after(grammarAccess.getLocationPrerequisiteAccess().getResourceIResourceCrossReference_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__LocationPrerequisite__PeripheralAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getLocationPrerequisiteAccess().getPeripheralPeripheralCrossReference_2_0()); }
		(
			{ before(grammarAccess.getLocationPrerequisiteAccess().getPeripheralPeripheralIIDParserRuleCall_2_0_1()); }
			ruleIID
			{ after(grammarAccess.getLocationPrerequisiteAccess().getPeripheralPeripheralIIDParserRuleCall_2_0_1()); }
		)
		{ after(grammarAccess.getLocationPrerequisiteAccess().getPeripheralPeripheralCrossReference_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__LocationPrerequisite__PositionAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getLocationPrerequisiteAccess().getPositionSymbolicPositionCrossReference_4_0()); }
		(
			{ before(grammarAccess.getLocationPrerequisiteAccess().getPositionSymbolicPositionIIDParserRuleCall_4_0_1()); }
			ruleIID
			{ after(grammarAccess.getLocationPrerequisiteAccess().getPositionSymbolicPositionIIDParserRuleCall_4_0_1()); }
		)
		{ after(grammarAccess.getLocationPrerequisiteAccess().getPositionSymbolicPositionCrossReference_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__NameAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getClaimAccess().getNameIIDParserRuleCall_1_0()); }
		ruleIID
		{ after(grammarAccess.getClaimAccess().getNameIIDParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__EntryAssignment_3_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getClaimAccess().getEntryTracePointParserRuleCall_3_0_0()); }
		ruleTracePoint
		{ after(grammarAccess.getClaimAccess().getEntryTracePointParserRuleCall_3_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__OuterEntryAssignment_3_1_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getClaimAccess().getOuterEntryTracePointParserRuleCall_3_1_0_0()); }
		ruleTracePoint
		{ after(grammarAccess.getClaimAccess().getOuterEntryTracePointParserRuleCall_3_1_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__EntryAssignment_3_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getClaimAccess().getEntryTracePointParserRuleCall_3_1_1_0()); }
		ruleTracePoint
		{ after(grammarAccess.getClaimAccess().getEntryTracePointParserRuleCall_3_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__PassiveAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getClaimAccess().getPassivePassiveKeyword_4_0()); }
		(
			{ before(grammarAccess.getClaimAccess().getPassivePassiveKeyword_4_0()); }
			'passive'
			{ after(grammarAccess.getClaimAccess().getPassivePassiveKeyword_4_0()); }
		)
		{ after(grammarAccess.getClaimAccess().getPassivePassiveKeyword_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__ResourceAssignment_6
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getClaimAccess().getResourceIResourceCrossReference_6_0()); }
		(
			{ before(grammarAccess.getClaimAccess().getResourceIResourceResourceQualifiedNameParserRuleCall_6_0_1()); }
			ruleResourceQualifiedName
			{ after(grammarAccess.getClaimAccess().getResourceIResourceResourceQualifiedNameParserRuleCall_6_0_1()); }
		)
		{ after(grammarAccess.getClaimAccess().getResourceIResourceCrossReference_6_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__ExitAssignment_7_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getClaimAccess().getExitTracePointParserRuleCall_7_0_0()); }
		ruleTracePoint
		{ after(grammarAccess.getClaimAccess().getExitTracePointParserRuleCall_7_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__ExitAssignment_7_1_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getClaimAccess().getExitTracePointParserRuleCall_7_1_0_0()); }
		ruleTracePoint
		{ after(grammarAccess.getClaimAccess().getExitTracePointParserRuleCall_7_1_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Claim__OuterExitAssignment_7_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getClaimAccess().getOuterExitTracePointParserRuleCall_7_1_1_0()); }
		ruleTracePoint
		{ after(grammarAccess.getClaimAccess().getOuterExitTracePointParserRuleCall_7_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__NameAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getReleaseAccess().getNameIIDParserRuleCall_1_0()); }
		ruleIID
		{ after(grammarAccess.getReleaseAccess().getNameIIDParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__EntryAssignment_3_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getReleaseAccess().getEntryTracePointParserRuleCall_3_0_0()); }
		ruleTracePoint
		{ after(grammarAccess.getReleaseAccess().getEntryTracePointParserRuleCall_3_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__OuterEntryAssignment_3_1_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getReleaseAccess().getOuterEntryTracePointParserRuleCall_3_1_0_0()); }
		ruleTracePoint
		{ after(grammarAccess.getReleaseAccess().getOuterEntryTracePointParserRuleCall_3_1_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__EntryAssignment_3_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getReleaseAccess().getEntryTracePointParserRuleCall_3_1_1_0()); }
		ruleTracePoint
		{ after(grammarAccess.getReleaseAccess().getEntryTracePointParserRuleCall_3_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__ResourceAssignment_5
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getReleaseAccess().getResourceIResourceCrossReference_5_0()); }
		(
			{ before(grammarAccess.getReleaseAccess().getResourceIResourceResourceQualifiedNameParserRuleCall_5_0_1()); }
			ruleResourceQualifiedName
			{ after(grammarAccess.getReleaseAccess().getResourceIResourceResourceQualifiedNameParserRuleCall_5_0_1()); }
		)
		{ after(grammarAccess.getReleaseAccess().getResourceIResourceCrossReference_5_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__ExitAssignment_6_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getReleaseAccess().getExitTracePointParserRuleCall_6_0_0()); }
		ruleTracePoint
		{ after(grammarAccess.getReleaseAccess().getExitTracePointParserRuleCall_6_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__ExitAssignment_6_1_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getReleaseAccess().getExitTracePointParserRuleCall_6_1_0_0()); }
		ruleTracePoint
		{ after(grammarAccess.getReleaseAccess().getExitTracePointParserRuleCall_6_1_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Release__OuterExitAssignment_6_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getReleaseAccess().getOuterExitTracePointParserRuleCall_6_1_1_0()); }
		ruleTracePoint
		{ after(grammarAccess.getReleaseAccess().getOuterExitTracePointParserRuleCall_6_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__RaiseEvent__NameAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getRaiseEventAccess().getNameIIDParserRuleCall_1_0()); }
		ruleIID
		{ after(grammarAccess.getRaiseEventAccess().getNameIIDParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__RaiseEvent__ResourceAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getRaiseEventAccess().getResourceIResourceCrossReference_4_0()); }
		(
			{ before(grammarAccess.getRaiseEventAccess().getResourceIResourceResourceQualifiedNameParserRuleCall_4_0_1()); }
			ruleResourceQualifiedName
			{ after(grammarAccess.getRaiseEventAccess().getResourceIResourceResourceQualifiedNameParserRuleCall_4_0_1()); }
		)
		{ after(grammarAccess.getRaiseEventAccess().getResourceIResourceCrossReference_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__RequireEvent__NameAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getRequireEventAccess().getNameIIDParserRuleCall_1_0()); }
		ruleIID
		{ after(grammarAccess.getRequireEventAccess().getNameIIDParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__RequireEvent__ResourceAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getRequireEventAccess().getResourceIResourceCrossReference_4_0()); }
		(
			{ before(grammarAccess.getRequireEventAccess().getResourceIResourceResourceQualifiedNameParserRuleCall_4_0_1()); }
			ruleResourceQualifiedName
			{ after(grammarAccess.getRequireEventAccess().getResourceIResourceResourceQualifiedNameParserRuleCall_4_0_1()); }
		)
		{ after(grammarAccess.getRequireEventAccess().getResourceIResourceCrossReference_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__NameAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMoveAccess().getNameIIDParserRuleCall_1_0()); }
		ruleIID
		{ after(grammarAccess.getMoveAccess().getNameIIDParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__EntryAssignment_3_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMoveAccess().getEntryTracePointParserRuleCall_3_0_0()); }
		ruleTracePoint
		{ after(grammarAccess.getMoveAccess().getEntryTracePointParserRuleCall_3_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__OuterEntryAssignment_3_1_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMoveAccess().getOuterEntryTracePointParserRuleCall_3_1_0_0()); }
		ruleTracePoint
		{ after(grammarAccess.getMoveAccess().getOuterEntryTracePointParserRuleCall_3_1_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__EntryAssignment_3_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMoveAccess().getEntryTracePointParserRuleCall_3_1_1_0()); }
		ruleTracePoint
		{ after(grammarAccess.getMoveAccess().getEntryTracePointParserRuleCall_3_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__ResourceAssignment_5
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMoveAccess().getResourceIResourceCrossReference_5_0()); }
		(
			{ before(grammarAccess.getMoveAccess().getResourceIResourceResourceQualifiedNameParserRuleCall_5_0_1()); }
			ruleResourceQualifiedName
			{ after(grammarAccess.getMoveAccess().getResourceIResourceResourceQualifiedNameParserRuleCall_5_0_1()); }
		)
		{ after(grammarAccess.getMoveAccess().getResourceIResourceCrossReference_5_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__PeripheralAssignment_7
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMoveAccess().getPeripheralPeripheralCrossReference_7_0()); }
		(
			{ before(grammarAccess.getMoveAccess().getPeripheralPeripheralIIDParserRuleCall_7_0_1()); }
			ruleIID
			{ after(grammarAccess.getMoveAccess().getPeripheralPeripheralIIDParserRuleCall_7_0_1()); }
		)
		{ after(grammarAccess.getMoveAccess().getPeripheralPeripheralCrossReference_7_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__PassingAssignment_8_0_0_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMoveAccess().getPassingPassingKeyword_8_0_0_0_0()); }
		(
			{ before(grammarAccess.getMoveAccess().getPassingPassingKeyword_8_0_0_0_0()); }
			'passing'
			{ after(grammarAccess.getMoveAccess().getPassingPassingKeyword_8_0_0_0_0()); }
		)
		{ after(grammarAccess.getMoveAccess().getPassingPassingKeyword_8_0_0_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__TargetPositionAssignment_8_0_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMoveAccess().getTargetPositionSymbolicPositionCrossReference_8_0_1_0()); }
		(
			{ before(grammarAccess.getMoveAccess().getTargetPositionSymbolicPositionIIDParserRuleCall_8_0_1_0_1()); }
			ruleIID
			{ after(grammarAccess.getMoveAccess().getTargetPositionSymbolicPositionIIDParserRuleCall_8_0_1_0_1()); }
		)
		{ after(grammarAccess.getMoveAccess().getTargetPositionSymbolicPositionCrossReference_8_0_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__ContinuingAssignment_8_1_0_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMoveAccess().getContinuingContinuingKeyword_8_1_0_0_0()); }
		(
			{ before(grammarAccess.getMoveAccess().getContinuingContinuingKeyword_8_1_0_0_0()); }
			'continuing'
			{ after(grammarAccess.getMoveAccess().getContinuingContinuingKeyword_8_1_0_0_0()); }
		)
		{ after(grammarAccess.getMoveAccess().getContinuingContinuingKeyword_8_1_0_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__DistanceAssignment_8_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMoveAccess().getDistanceDistanceCrossReference_8_1_1_0()); }
		(
			{ before(grammarAccess.getMoveAccess().getDistanceDistanceIIDParserRuleCall_8_1_1_0_1()); }
			ruleIID
			{ after(grammarAccess.getMoveAccess().getDistanceDistanceIIDParserRuleCall_8_1_1_0_1()); }
		)
		{ after(grammarAccess.getMoveAccess().getDistanceDistanceCrossReference_8_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__ProfileAssignment_9_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMoveAccess().getProfileProfileCrossReference_9_1_0()); }
		(
			{ before(grammarAccess.getMoveAccess().getProfileProfileIIDParserRuleCall_9_1_0_1()); }
			ruleIID
			{ after(grammarAccess.getMoveAccess().getProfileProfileIIDParserRuleCall_9_1_0_1()); }
		)
		{ after(grammarAccess.getMoveAccess().getProfileProfileCrossReference_9_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__SchedulingTypeAssignment_10
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMoveAccess().getSchedulingTypeSchedulingEnumRuleCall_10_0()); }
		ruleScheduling
		{ after(grammarAccess.getMoveAccess().getSchedulingTypeSchedulingEnumRuleCall_10_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__ExitAssignment_11_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMoveAccess().getExitTracePointParserRuleCall_11_0_0()); }
		ruleTracePoint
		{ after(grammarAccess.getMoveAccess().getExitTracePointParserRuleCall_11_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__ExitAssignment_11_1_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMoveAccess().getExitTracePointParserRuleCall_11_1_0_0()); }
		ruleTracePoint
		{ after(grammarAccess.getMoveAccess().getExitTracePointParserRuleCall_11_1_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Move__OuterExitAssignment_11_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getMoveAccess().getOuterExitTracePointParserRuleCall_11_1_1_0()); }
		ruleTracePoint
		{ after(grammarAccess.getMoveAccess().getOuterExitTracePointParserRuleCall_11_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__NameAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getSimpleActionAccess().getNameIIDParserRuleCall_1_0()); }
		ruleIID
		{ after(grammarAccess.getSimpleActionAccess().getNameIIDParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__EntryAssignment_3_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getSimpleActionAccess().getEntryTracePointParserRuleCall_3_0_0()); }
		ruleTracePoint
		{ after(grammarAccess.getSimpleActionAccess().getEntryTracePointParserRuleCall_3_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__OuterEntryAssignment_3_1_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getSimpleActionAccess().getOuterEntryTracePointParserRuleCall_3_1_0_0()); }
		ruleTracePoint
		{ after(grammarAccess.getSimpleActionAccess().getOuterEntryTracePointParserRuleCall_3_1_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__EntryAssignment_3_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getSimpleActionAccess().getEntryTracePointParserRuleCall_3_1_1_0()); }
		ruleTracePoint
		{ after(grammarAccess.getSimpleActionAccess().getEntryTracePointParserRuleCall_3_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__ResourceAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getSimpleActionAccess().getResourceIResourceCrossReference_4_0()); }
		(
			{ before(grammarAccess.getSimpleActionAccess().getResourceIResourceResourceQualifiedNameParserRuleCall_4_0_1()); }
			ruleResourceQualifiedName
			{ after(grammarAccess.getSimpleActionAccess().getResourceIResourceResourceQualifiedNameParserRuleCall_4_0_1()); }
		)
		{ after(grammarAccess.getSimpleActionAccess().getResourceIResourceCrossReference_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__PeripheralAssignment_5_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getSimpleActionAccess().getPeripheralPeripheralCrossReference_5_1_0()); }
		(
			{ before(grammarAccess.getSimpleActionAccess().getPeripheralPeripheralIIDParserRuleCall_5_1_0_1()); }
			ruleIID
			{ after(grammarAccess.getSimpleActionAccess().getPeripheralPeripheralIIDParserRuleCall_5_1_0_1()); }
		)
		{ after(grammarAccess.getSimpleActionAccess().getPeripheralPeripheralCrossReference_5_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__TypeAssignment_5_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getSimpleActionAccess().getTypeActionTypeCrossReference_5_3_0()); }
		(
			{ before(grammarAccess.getSimpleActionAccess().getTypeActionTypeIIDParserRuleCall_5_3_0_1()); }
			ruleIID
			{ after(grammarAccess.getSimpleActionAccess().getTypeActionTypeIIDParserRuleCall_5_3_0_1()); }
		)
		{ after(grammarAccess.getSimpleActionAccess().getTypeActionTypeCrossReference_5_3_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__SchedulingTypeAssignment_6
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getSimpleActionAccess().getSchedulingTypeSchedulingEnumRuleCall_6_0()); }
		ruleScheduling
		{ after(grammarAccess.getSimpleActionAccess().getSchedulingTypeSchedulingEnumRuleCall_6_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__ExitAssignment_7_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getSimpleActionAccess().getExitTracePointParserRuleCall_7_0_0()); }
		ruleTracePoint
		{ after(grammarAccess.getSimpleActionAccess().getExitTracePointParserRuleCall_7_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__ExitAssignment_7_1_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getSimpleActionAccess().getExitTracePointParserRuleCall_7_1_0_0()); }
		ruleTracePoint
		{ after(grammarAccess.getSimpleActionAccess().getExitTracePointParserRuleCall_7_1_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__SimpleAction__OuterExitAssignment_7_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getSimpleActionAccess().getOuterExitTracePointParserRuleCall_7_1_1_0()); }
		ruleTracePoint
		{ after(grammarAccess.getSimpleActionAccess().getOuterExitTracePointParserRuleCall_7_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__TracePoint__RegexAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getTracePointAccess().getRegexTildeKeyword_1_0()); }
		(
			{ before(grammarAccess.getTracePointAccess().getRegexTildeKeyword_1_0()); }
			'~'
			{ after(grammarAccess.getTracePointAccess().getRegexTildeKeyword_1_0()); }
		)
		{ after(grammarAccess.getTracePointAccess().getRegexTildeKeyword_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__TracePoint__ValueAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getTracePointAccess().getValueEStringParserRuleCall_2_0()); }
		ruleEString
		{ after(grammarAccess.getTracePointAccess().getValueEStringParserRuleCall_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Edge__SourceAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEdgeAccess().getSourceSourceReferenceParserRuleCall_1_0()); }
		ruleSourceReference
		{ after(grammarAccess.getEdgeAccess().getSourceSourceReferenceParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Edge__TargetAssignment_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEdgeAccess().getTargetDependencyTargetParserRuleCall_3_0()); }
		ruleDependencyTarget
		{ after(grammarAccess.getEdgeAccess().getTargetDependencyTargetParserRuleCall_3_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__SourceReference__NodeAssignment_1_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getSourceReferenceAccess().getNodeActionCrossReference_1_0_0()); }
		(
			{ before(grammarAccess.getSourceReferenceAccess().getNodeActionIIDParserRuleCall_1_0_0_1()); }
			ruleIID
			{ after(grammarAccess.getSourceReferenceAccess().getNodeActionIIDParserRuleCall_1_0_0_1()); }
		)
		{ after(grammarAccess.getSourceReferenceAccess().getNodeActionCrossReference_1_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__SourceReference__NodeAssignment_1_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getSourceReferenceAccess().getNodeSyncBarCrossReference_1_1_1_0()); }
		(
			{ before(grammarAccess.getSourceReferenceAccess().getNodeSyncBarIIDParserRuleCall_1_1_1_0_1()); }
			ruleIID
			{ after(grammarAccess.getSourceReferenceAccess().getNodeSyncBarIIDParserRuleCall_1_1_1_0_1()); }
		)
		{ after(grammarAccess.getSourceReferenceAccess().getNodeSyncBarCrossReference_1_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__TargetReference__NodeAssignment_1_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getTargetReferenceAccess().getNodeActionCrossReference_1_0_0()); }
		(
			{ before(grammarAccess.getTargetReferenceAccess().getNodeActionIIDParserRuleCall_1_0_0_1()); }
			ruleIID
			{ after(grammarAccess.getTargetReferenceAccess().getNodeActionIIDParserRuleCall_1_0_0_1()); }
		)
		{ after(grammarAccess.getTargetReferenceAccess().getNodeActionCrossReference_1_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__TargetReference__NodeAssignment_1_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getTargetReferenceAccess().getNodeSyncBarCrossReference_1_1_1_0()); }
		(
			{ before(grammarAccess.getTargetReferenceAccess().getNodeSyncBarIIDParserRuleCall_1_1_1_0_1()); }
			ruleIID
			{ after(grammarAccess.getTargetReferenceAccess().getNodeSyncBarIIDParserRuleCall_1_1_1_0_1()); }
		)
		{ after(grammarAccess.getTargetReferenceAccess().getNodeSyncBarCrossReference_1_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Event__NameAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEventAccess().getNameIDTerminalRuleCall_1_0()); }
		RULE_ID
		{ after(grammarAccess.getEventAccess().getNameIDTerminalRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Event__ItemsAssignment_2_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEventAccess().getItemsEventItemParserRuleCall_2_1_0()); }
		ruleEventItem
		{ after(grammarAccess.getEventAccess().getItemsEventItemParserRuleCall_2_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Event__ItemsAssignment_2_2_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEventAccess().getItemsEventItemParserRuleCall_2_2_1_0()); }
		ruleEventItem
		{ after(grammarAccess.getEventAccess().getItemsEventItemParserRuleCall_2_2_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EventItem__NameAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEventItemAccess().getNameIIDParserRuleCall_1_0()); }
		ruleIID
		{ after(grammarAccess.getEventItemAccess().getNameIIDParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

RULE_ID : '^'? ('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*;

RULE_INT : ('0'..'9')+;

RULE_STRING : ('"' ('\\' .|~(('\\'|'"')))* '"'|'\'' ('\\' .|~(('\\'|'\'')))* '\'');

RULE_ML_COMMENT : '/*' ( options {greedy=false;} : . )*'*/';

RULE_SL_COMMENT : '//' ~(('\n'|'\r'))* ('\r'? '\n')?;

RULE_WS : (' '|'\t'|'\r'|'\n')+;

RULE_ANY_OTHER : .;
